#! /usr/bin/python3
# -*- coding: UTF-8 -*-
#
# 26.09.2014
#
# siehe fdc_3402.c


# eine rudimentäre Unterstützung der IR-Tastatur
# berücksichtigt die Shift- und AltGr-Tasten und Return

class Irmp_FDC(object):
    def __init__(self):

        self.key_tab = (
        #   0    1    2    3    4    5    6    7    8    9    A    B    C    D    E    F
            0,  '^', '1', '2', '3', '4', '5', '6', '7', '8', '9', '0', 'ß', '´',  0,  '\b',
           '\t','q', 'w', 'e', 'r', 't', 'z', 'u', 'i', 'o', 'p', 'ü', '+',  0,   0,  'a',
           's', 'd', 'f', 'g', 'h', 'j', 'k', 'l', 'ö', 'ä', '#',  '\r', 0,  '<', 'y', 'x',
           'c', 'v', 'b', 'n', 'm', ',', '.', '-',  0,   0,   0,   0,   0,  ' ',  0,   0,

            0,  '°', '!', '"', '§', '$', '%', '&', '/', '(', ')', '=', '?', '`',  0,  '\b',
           '\t','Q', 'W', 'E', 'R', 'T', 'Z', 'U', 'I', 'O', 'P', 'Ü', '*',  0,   0,  'A',
           'S', 'D', 'F', 'G', 'H', 'J', 'K', 'L', 'Ö', 'Ä', '\'','\r', 0,  '>', 'Y', 'X',
           'C', 'V', 'B', 'N', 'M', ';', ':', '_',  0,   0,   0,   0,   0,  ' ',  0,   0 )

        self.left_shift  = False
        self.right_shift = False
        self.left_alt    = False
        self.right_alt   = False
        self.left_ctrl   = False


    def get_chr(self, code):
        if self.test_shift_alt(code):
            return

        if not (code & 0x0080):
            if code == 0x002B: char = '\n'

            elif self.right_alt:
                if   code == 0x0003: char = '²'
                elif code == 0x0008: char = '{'
                elif code == 0x0009: char = '['
                elif code == 0x000A: char = ']'
                elif code == 0x000B: char = '}'
                elif code == 0x000C: char = '\\'
                elif code == 0x001C: char = '~'
                elif code == 0x002D: char = '|'
                else: char = None

            elif code < 64:
                if self.left_shift or self.right_shift:
                    code += 64

                char = self.key_tab[code]

            else:
                char = None

            print(code, char)
            return char


    def test_shift_alt(self, code):
        ret = True
        if   code == 0x002c: self.left_shift  = True
        elif code == 0x00ac: self.left_shift  = False
        elif code == 0x0039: self.right_shift = True
        elif code == 0x00b9: self.right_shift = False
        elif code == 0x003c: self.left_alt    = True
        elif code == 0x00bc: self.left_alt    = False
        elif code == 0x003e: self.right_alt   = True
        elif code == 0x00be: self.right_alt   = False
        else: ret = False
        return ret


if __name__ == '__main__':
    c = Irmp_FDC()
    c.get_chr(34)
