#!/usr/bin/python
# -*- coding: UTF-8 -*-
#
# 26.09.2014
#
# --- [ simple_editor ] --------------------------------------------------------
#
# Ein einfacher Texteditor mit vertikalem und horizontalem Scrollbar.
# Ein Button zum Löschen des gesamten Fensterinhaltes ist eingebaut.

import tkinter as tk

class Editor(tk.Text):

    def __init__(self, master,
                 row = 0,
                 column = 0,
                 columnspan = 1,
                 width  = 40,
                 height = 10 ):

        tk.Text.__init__(self, master,
                         height = height,
                         width = width )

        self.grid(column = column, columnspan = columnspan, row = row, \
                    padx = 5, pady = 5, sticky = "nsew")

        # Der Editor erhält einen Scrollbar für die vertikale Richtung.
        yscrollbar = tk.Scrollbar(master)
        yscrollbar.grid(column = column + columnspan, row = row,
                    pady = 5, sticky = "nsw")
        yscrollbar.config(command = self.yview)
        self.configure(yscrollcommand = yscrollbar.set)

        # Der Editor erhält einen Scrollbar für die horizontale Richtung.
        xscrollbar = tk.Scrollbar(master, orient = "horizontal", width = 20)
        xscrollbar.grid(column = column, columnspan = columnspan, row = row + 1,
                    padx = 5, sticky = "new")
        xscrollbar.config(command = self.xview)
        self.configure(xscrollcommand = xscrollbar.set, wrap = "none")

        # Der Editor erhält einen Button zum Löschen des Inhaltes.
        tk.Button(master, text = "X", command = self._txt_delete).\
                        grid(column = column + columnspan, row = row + 1,
                        pady = 0, sticky = "nsew")


    def _txt_delete(self):
        self.delete('1.0', 'end')

# --- [ eof ] ------------------------------------------------------------------